import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class CheckLock {

    private static Lock lock = new ReentrantLock();

    public static void main(String[] args) {
        Thread thread1 = new Thread(new Worker());
        Thread thread2 = new Thread(new Worker());

        // Start the threads
        thread1.start();
        thread2.start();
    }

    static class Worker implements Runnable {
        @Override
        public void run() {
            // Acquire the lock
            lock.lock();

            try {
                System.out.println(Thread.currentThread().getName() + " acquired the lock.");

                // Perform some work
                for (int i = 0; i < 5; i++) {
                    System.out.println(Thread.currentThread().getName() + " is working.");
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }

            } finally {
                // Release the lock
                lock.unlock();
                System.out.println(Thread.currentThread().getName() + " released the lock.");
            }
        }
    }
}