import java.util.HashSet;
import java.util.Objects;

class EqualsHashCode {
    private String name;
    private int age;

    public EqualsHashCode(String name, int age) {
        this.name = name;
        this.age = age;
    }

    // 如果没有这个重写，最后personSet中会有两个对象
    public int hashCode() {
        return Objects.hash(name, age);
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == this) {
            return true;
        }

        if (obj == null || obj.getClass() != this.getClass()) {
            return false;
        }

        EqualsHashCode other = (EqualsHashCode) obj;
        return this.name.equals(other.name) && this.age == other.age;
    }

    public static void main(String[] args) {
        EqualsHashCode person1 = new EqualsHashCode("John", 25);
        EqualsHashCode person2 = new EqualsHashCode("John", 25);

        HashSet<EqualsHashCode> personSet = new HashSet<>();
        personSet.add(person1);
        personSet.add(person2);
        System.out.println(personSet);
    }
}