import java.util.ArrayList;
import java.util.ConcurrentModificationException;
import java.util.Iterator;
import java.util.List;

public class ForLoopAddRemove {

    public static void main(String[] args) {
        List<Integer> numbers = new ArrayList<>();
        for (int i = 0; i < 10; i++) {
            numbers.add(i);
        }

        // Create a thread to remove elements using foreach
        Thread thread1 = new Thread(() -> {
            try {
                for (Integer number : numbers) {
                    System.out.println("Removing element using foreach: " + number);
                    numbers.remove(number); // ConcurrentModificationException will occur
                }
            } catch (ConcurrentModificationException e) {
                System.out.println("Caught ConcurrentModificationException when modifying list using foreach.");
            }
        });

        // Create a thread to remove elements using iterator
        Thread thread2 = new Thread(() -> {
            Iterator<Integer> iterator = numbers.iterator();
            while (iterator.hasNext()) {
                Integer number = iterator.next();
                System.out.println("Removing element using iterator: " + number);
                iterator.remove(); // Works fine with iterator
            }
        });

        // Start the threads
        thread1.start();
        thread2.start();
    }
}