package fanshe;

import java.rmi.*;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

//4. 创建客户程序
//下例的 SimpleClient 类先获得远程对象的存根对象，接着调用它的远程方法



public class SimpleClient {

    public static void main(String args[]) throws RemoteException {
        try {
            //返回本地主机的RMI注册器对象,参数port指定RMI注册器监听的端口
            Registry registry = LocateRegistry.getRegistry(1099);
            //查找对象,返回与参数name指定的名字所绑定的对象
            //返回的是一个名为"com.sun.proxy.$Proxy0"的动态代理类的实例
            GreetingService service1 = (GreetingService) registry.lookup("GreetingService1");
            GreetingService service2 = (GreetingService) registry.lookup("GreetingService2");

            System.out.println(service1.remoteGreet(new StringBuffer("Greetings!")));
            System.out.println(service2.remoteGreet(new StringBuffer("Greetings!")));
        } catch (NotBoundException e) {
            throw new RuntimeException(e);
        }
    }
}