package fanshe;

import java.rmi.*;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

//3. 创建服务器程序
//RMI 采用一种命名服务机制来使得客户程序可以找到服务器上的一个远程对象，RMI注册器提供这种命名服务。好比电话查询系统，\
//那些希望对外公开联系方式的单位先到查询系统登记，当客户想知道某个单位的联系方式时，只需向查询系统提供单位的名字，查询\
//系统就会返回该单位的联系方式

public class SimpleServer {

    public static void main( String args[]) {
        try {
            GreetingService service1 = new GreetingServiceImp(new StringBuffer("service1"));
            GreetingService service2 = new GreetingServiceImp(new StringBuffer("service2"));

            //创建并启动注册器
            Registry registry = LocateRegistry.createRegistry(1099);
            //注册远程对象
            registry.rebind("GreetingService1", service1);
            registry.rebind("GreetingService2", service2);
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
}
