package org.example.jdkSerializable;

import java.io.*;

public class SerializableUtil {
    /**
     * 序列化方法
     * @param obj
     * @param fileName
     * @throws IOException
     */
    public static void serialize(Object obj,String fileName) throws IOException {
        FileOutputStream fos = new FileOutputStream(fileName);
        ObjectOutputStream oos = new ObjectOutputStream(fos);
        oos.writeObject(obj);
        oos.close();
        fos.close();
    }
    /**
     * 反序列化方法
     * @param fileName
     * @return
     * @throws Exception
     */
    public static Object deserialize(String fileName) throws Exception {
        FileInputStream fis = new FileInputStream(fileName);
        ObjectInputStream ois = new ObjectInputStream(fis);
        Object object = ois.readObject();
        ois.close();
        fis.close();
        return object;
    }
    public static void main(String[] args) throws Exception {
        Account account = new Account();
        account.setId(1L);
        account.setAccount("chase");
        account.setEmail("wfp_chase@163.com");
        account.setPassword("********");
        serialize(account,"account");
        Account result = (Account) deserialize("account");
        System.out.println(account);
        System.out.println(result);
    }
}
