import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class SynchronizedTest implements Runnable{
    private static int i = 0;

    public synchronized void getI() throws InterruptedException {
        if (i % 1000000 == 0) {

            System.out.println(i+"--"+Thread.currentThread());
//            Thread.sleep(5000);
        }
    }

    public synchronized void increase() throws InterruptedException {
        i++;
        getI();
    }

    @Override
    public void run() {
        for (int j = 0; j < 1000000; j++) {
            try {
                increase();
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }

        System.out.println(i+"--"+Thread.currentThread());
    }

    public static void main(String[] args) {
        ExecutorService executorService = Executors.newCachedThreadPool();
        SynchronizedTest synchronizedTest = new SynchronizedTest();
        SynchronizedTest synchronizedTest1 = new SynchronizedTest();
        executorService.execute(synchronizedTest);
        executorService.execute(synchronizedTest1);
        executorService.shutdown();
    }
}